﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.01
@EndOfDesignText@
#Region  Activity Attributes
	#FullScreen: true
	#IncludeTitle: True
#End Region
' =======================================================================================
' Description ...: Chart Generator
' Requirement(s).: Basic4Android 6.31
' Author ........: Giovanni Rossati (El Condor)
' Version........: 0.2.1
' Date...........: 13 May 2019
' License........: Free to use without any warranties
' =======================================================================================
Sub Process_Globals
'	Type GraphInternal (originX As Int, zeroY As Int, originY As Int, maxY As Int, gw As Int, gh As Int,xTicksNumber As Int)
	Type GraphInternal (originX As Int, zeroY As Int, originY As Int, maxY As Int, gw As Int, gh As Int)
	Type Graph (GI As GraphInternal, Title As String, YAxis As String, XAxis As String, _
		xAxisColor As Int, xAxisLabelColor As Int,yAxisColor As Int, yAxisLabelColor As Int,ChartType As String)
	'	*************** data structure *******************
	Type data(chartType As String, _
					Name As String, _			' data name
					color As Int, _				' visualisation color for data (not applicable to pie and ring)
					color2 As Int, _			' second color, for negative value of relative bar
					data() As Float, _			' set of data
					hasData() As Boolean, _		' if data exists
					Labels() As String, _		' labels for item data
					Minimum As Float, _			' minimum found
					Maximum As Float, _			' maximum found
					slice As Int, _				' angle in grade for non complete pie or ring 
					maxDataLabelWidth As Int, _	' maximum width of labels of item data
					maxLabelWidth As Int, _		' maximum width data description
					intervalX As Float)			' point distance
	Dim chartsTypeMap As Map = CreateMap("Area":0,"Areabar":0,"Bar":0,"Bubble":0,"Delta":0,"Hbar":0,"Line":0,"Pie":0, _
					"Map":0,"Point":0,"Ring":0,"Scatter":0,"Venn":0)
	Dim itemsMap As Map
	Dim keys As Map
	Dim colorsMap As Map = CreateMap("red":Colors.red,"green":Colors.green,"blue":Colors.blue, "magenta":Colors.Magenta, _
							"yellow":Colors.Yellow,"gray":Colors.Gray,"lightgray":Colors.LightGray,"cyan":Colors.Cyan, _
							"black":Colors.Black,"teal":Colors.RGB(0,127,127),"whithe":Colors.White,"transparent":Colors.ARGB(0,0,0,255), _
							"olive":Colors.RGB(127,127,0),"aqua":Colors.RGB(0,255,255),"orange":Colors.RGB(255,165,0), _
							"silver":Colors.RGB(192,192,192),"crimson":Colors.RGB(220,20,60), "purple":Colors.RGB(128,0,128))						
	' points charts or vertical Bar charts
	Dim chartPoints As Map = CreateMap("areabar":"","bar":"","bubble":"","delta":"","point":"")
	Dim objectsColorMap As Map
	Dim replacerMap As Map = CreateMap()
	Type replacer(param As String, Value As String)
	Dim objectsKey As String = ""	' for assigne colors
	Dim chartParams As String 		' save parameters
	Dim G As Graph
	Dim GI As GraphInternal
	Dim dataChart As List	' contains data type data for build a chart
	Dim areaPointsMap As Map = CreateMap("bottom":"","top":"")	' for create path on area chart
	Private Minimum,Maximum As Float	' minimum and maximum of data
	Dim listExploded As List			' for pie and ring
	'	**************** regular expresions
	Dim reSepareTokens As String = "'(.*?)'|(\S+)"	' separe tokens on space or apostrophe delimited
	Dim reCommaSeparator As String = "\s*,\s*"
	Dim reSpaceOrComma As String = "\s*,\s*|\s+"	' for explode slice
	Dim reSepareNumericTokens As String = "([+-]?[0-9]*[.]?[0-9]+|\*)"	' separe numeric tokens with * means data lacks
	Dim reSplitTokens As String = "\s*([^,]*)\s*,|([^\s,]+)"	' split tokens on space or comma \s*([^,]+)\s*,|([^\s,]+)
	Dim reSplitColors As String = "([xX][0-9a-fA-F]{1,8})|([a-zA-Z]+\s+\d{1,3})|([a-zA-Z]+)"
	Dim reExtractPlaceholders As String = "(%\w*\(\d+ \d*\))|(%\w*)"
	Dim reExtractLimits As String = "^\s*(-?\d+\.?\d+|-?\d+)\s*(-?\d+\.?\d+|-?\d+)\s*(-?\d+\.?\d+|-?\d+)\s*(-?\d+\.?\d+|-?\d+)\s*$"
	'	**************** regular expresions
	Dim orientation As Int		' orientation
'	Dim bestXInterval As Int = 20dip	' best vertical lines
	Type CubicSlpanePoint(X As Float,Y As Float, p As Float, u As Float)
	Dim pointsList As List
	Dim headerHeight  As Int = 38dip
	Dim numericLabels() As Float
	Dim dataNames() As String	' data names (description)
	Dim Labels() As String		' Map labels
End Sub
Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim target As Panel
	Dim labelClose As Label
	Dim canvas As Canvas
	Dim aColors As List		' charts color
	Private fileName As EditText
	Private jpg As RadioButton
	Private png As RadioButton
	Private dlgPanel As Panel
	Type ls(s As Object, index As Int)	' for sorting purpose
	Dim legendPosition As Int ' legend position 
End Sub
Sub Activity_Create(FirstTime As Boolean)
	aColors.Initialize
	Activity.AddMenuItem("Save Image","wImage")
	If chartParams <> "" Then Chart(chartParams)	' in case of change orientation
	replacerMap.Put("%date",DateTime.Date(DateTime.Now))
End Sub
Sub Activity_Resume
End Sub
Sub Activity_Pause (UserClosed As Boolean)
End Sub
Sub Chart(param As String)
	keys = CreateMap("align":"CENTER","border":"","chart":"","data":"","color":"","ground":"","slice":360, _
					"xaxis":"","yaxis":"","explode":"","labels":"","show":"%v","title":"","titleX":"","titleY":"", _
					"smooth":"%v","overlap":0,"sorted":0,"stacked":"","maximum":0,"minimum":0,"background":"","limits":"", _
					"inside":"")
	chartParams = param
	target.Initialize("pnlGraph")
	Activity.AddView(target, 5%x, 8%y, 90%x, 90%y)
	labelClose.Initialize("GraphClose")
	labelClose.TextSize = 18
	labelClose.Text = Chr(10008)
	labelClose.TextColor = Colors.red
	Activity.AddView(labelClose,90%x,10dip,30dip,30dip)			' cancel graph
'	cnvs = chart(pnlGraph,param)
'End Sub
'Sub chart(target As Panel,params As String) As Canvas
	objectsColorMap = CreateMap("yaxis":Colors.Gray,"label_yaxis":Colors.Black, _
		"xaxis":Colors.Gray,"label_xaxis":Colors.Black,"chart":Colors.RGB(192,192,192))
	itemsMap.Initialize
	Dim widgets() As String
	widgets = Regex.Split(";\s*"," " & param)
	Dim listParms As List
	dataChart.initialize
	listParms.Initialize
	legendPosition = 0
	For iw = 0 To widgets.Length - 1
		Dim Keyword As String = ""	' store the preceeding key
		Dim mtch As Matcher = Regex.Matcher(reSepareTokens,widgets(iw))
		Do While mtch.Find
			Dim key As String = mtch.Match.ToLowerCase
			If keys.ContainsKey(key) Then
				Keyword = key
				If "titleyaxisxaxischartdata".Contains(key) Then
					objectsKey = key	' for assigne color
				End If
				itemsMap.Put(key,Array As String())
				listParms.Clear
			Else
				If Keyword <> "" Then
					listParms.Add(removeDelimiters(mtch.Group(0)))
				End If
				itemsMap.Put(Keyword,list2Array(listParms))
				If Keyword = "color" Then
					If objectsKey = "chart" Then
						objectsColorMap.Put(objectsKey,possibleGradient(removeDelimiters(mtch.Group(0))))
					Else If objectsKey = "data" Then
						aColors = splitColors(mtch.Group(0))
					Else If objectsKey = "xaxis" Or objectsKey = "yaxis"  Or objectsKey = "title" Then
						Dim arrayColors As List
						arrayColors.Initialize2(splitColors(mtch.Group(0)))
						If arrayColors.size > 0 Then
'							objectsColorMap.Put("bg_" & objectsKey,colorsMap.get("silver"))
							objectsColorMap.Put("label_" & objectsKey,arrayColors.get(0))	' label color
							objectsColorMap.Put(objectsKey,arrayColors.get(0))	' axis or title color
							If arrayColors.size = 2 Then							
								If objectsKey = "title" Then 
									objectsColorMap.Put("bg_" & objectsKey,arrayColors.get(1))
								Else
									objectsColorMap.Put(objectsKey,arrayColors.get(1))	' axis color
								End If
							End If
						End If
					Else
						objectsColorMap.Put(objectsKey,interpColor(removeDelimiters(mtch.Group(0))))
					End If
				End If
			End If
		Loop
		' controls and arrange data *********************
		If itemsMap.ContainsKey("data") Then
			Dim chartData() As String = itemsMap.Get("data")
			If chartData.Length = 1 Then
				Dim aData() As String = Regex.Split(reCommaSeparator,chartData(0))		' data is Pie possibly names are ignored
			Else
				Dim aData() As String = Regex.Split(reCommaSeparator,chartData(1))		' data
			End If
			Dim dataNames() As String = Regex.Split(reCommaSeparator,chartData(0))		' data title
			Private aItems(,) As String = getDataArray(aData)			' get a data array
			For j = 0 To aItems.Length - 1
				Dim itemData As data
				itemData.Initialize
				itemData.chartType = getItem("chart","line").ToLowerCase
				itemData.hasData = getHasData(aItems,j)
				itemData.data = getRow(aItems,j)
				searchMinMax(itemData)	' set maximum and minimum of set
				If j = 0 And itemsMap.ContainsKey("labels") Then
					itemData.labels = getItems(replace(getItem("labels","")),reSplitTokens)
					If itemData.chartType = "map" Then Labels = itemData.labels	'getItems(replace(getItem("labels","")),reSplitTokens)
				End If
				If j < dataNames.Length Then itemData.Name = dataNames(j)
				itemData.color = getColor(j)
				itemData.color2 = itemData.color	' second color, for negative value of relative bar (for now)
				If aColors.size > aItems.Length Then itemData.color2 = getColor(j+1)	' it works well only for 1 data set
				dataChart.Add(itemData)
			Next
			itemsMap.Remove("data")
		End If
	Next
'	Dim itemData As data = dataChart.get(0)
	For k = 0 To dataChart.Size - 1
		Dim itemData As data = dataChart.get(k)
		If "pieringvenn".Contains(itemData.chartType) And k = 0 Then
			target.Height = 0.80 * target.Height
			If getItem("slice",360) < 181 Then target.Height = 0.75 * target.Height
		else If itemData.chartType = "scatter" Or itemData.chartType = "map" Then
			If k < 2 Then
				itemData.Maximum = hLimit(itemData.Maximum)
				itemData.Minimum = lLimit(itemData.Minimum)
			End If
			If k = 1 Then	' this sets the y labels value
				Maximum = itemData.Maximum
				Minimum = itemData.Minimum
			End If
		else If itemData.chartType = "bubble" Then
			Maximum = itemData.Maximum
			Minimum = itemData.Minimum
			Exit
		Else
			If Minimum > itemData.Minimum Then Minimum = itemData.Minimum
			If itemsMap.ContainsKey("stacked") Then
				If k > 0 Then Maximum = Maximum + itemData.Maximum
			Else
				If Maximum < itemData.Maximum Then Maximum = itemData.Maximum			
			End If
		End If
	Next
	Maximum = hLimit(Maximum)
	Minimum = lLimit(Minimum)
	If itemsMap.ContainsKey("minimum") Then Minimum = getItem("minimum","")
	If itemsMap.ContainsKey("maximum") Then Maximum = getItem("maximum","")
	' start drawing
	Dim canvas As Canvas
	canvas.Initialize(target)
	Dim destRect As Rect
	destRect.Initialize(0,0,target.Width,target.Height)	' chart space
	Dim groundColor As Object = objectsColorMap.Get("chart")
	If TypeOf(groundColor) = "Integer" Then canvas.DrawColor(groundColor)
	If TypeOf(groundColor) = "ArrayList" Then
		canvas.DrawDrawable(createGradient(groundColor), destRect)
	End If
	If itemsMap.ContainsKey("background") Then
		Dim fileInfo As Map = pathinfo(getItem("background",""))
		If fileInfo.Get("dirname") = "" Then fileInfo.Put("dirname",File.DirAssets)
		If File.Exists(fileInfo.Get("dirname"),fileInfo.Get("basename")) Then
			Dim bmp As Bitmap
			bmp.Initialize(fileInfo.Get("dirname"),fileInfo.Get("basename"))
			destRect.Initialize(0,0,target.Width,target.Height)	' chart space
			canvas.DrawBitmap(bmp, Null, destRect) 'draws the bitmap to the destination rectangle.
		End If
	End If
	' title background
	destRect.Initialize(0,0,target.Width,headerHeight)
	canvas.DrawRect(destRect,objectsColorMap.GetDefault("bg_title",Colors.ARGB(1,0,0,0)), True,1dip)
	If itemsMap.ContainsKey("border") Then
		destRect.Initialize(1dip,1dip,target.Width-1dip,target.Height-1dip)
		canvas.DrawRect(destRect,Colors.ARGB(255,0,0,127),False,3dip)
		canvas.DrawLine(0,headerHeight,target.Width,headerHeight,Colors.ARGB(127,0,0,127),2dip)
	End If
	G.Initialize
	G.GI = GI
	GI.Initialize
	GI.maxY = headerHeight + 15dip
	GI.originX = 50dip
	GI.originY = target.Height - 53dip
	GI.gw = target.Width - 75dip 'graph width
	GI.gh = GI.originY - GI.maxY 'graph height	' create axis
	GI.zeroY = headerHeight + 15dip
	Dim existsAxis As Boolean = False
	For Each chartType As String In chartsTypeMap.Keys
		Dim listDataCharts As List
		listDataCharts.Initialize
		For k = 0 To dataChart.Size - 1
			Dim d As data = dataChart.Get(k)
			If chartType.ToLowerCase = d.chartType Then listDataCharts.Add(d)
		Next
		If listDataCharts.Size = 0 Then Continue
		Dim dd(listDataCharts.Size) As data
		For k = 0 To listDataCharts.Size - 1
			dd(k) = listDataCharts.Get(k)
		Next
		G.ChartType = chartType
		replacerMap.put("%chart",chartType.SubString2(0,1).ToUpperCase & chartType.SubString(1).ToLowerCase)
		G.xAxisColor = objectsColorMap.getDefault("xaxis",Colors.Gray)
		G.yAxisColor = objectsColorMap.getDefault("yaxis",Colors.Gray)
		G.yAxisLabelColor = objectsColorMap.getDefault("label_yaxis",Colors.Black)
		G.xAxisLabelColor = objectsColorMap.getDefault("label_xaxis",Colors.Black)
		G.XAxis = replace(getItem("xaxis","X Axis"))
		G.YAxis = replace(getItem("yaxis","Y Axis"))
		G.title = replace(getItem("title","%Chart %date"))
		Dim align As String = getItem("align","CENTER")
		Dim x As Int = 5dip
		If align = "CENTER" Then x = target.Width/2
		If align = "RIGHT" Then x = target.Width - 10
		Dim nIntervalsX As Int = Max(dd(0).labels.Length,dd(0).data.Length)' intervals are max of # labels and # data
		dd(0).intervalx = GI.gw/(nIntervalsX-1)
		If chartPoints.ContainsKey(chartType.ToLowerCase) Then dd(0).intervalx = GI.gw/nIntervalsX
		If itemsMap.ContainsKey("stacked") Then
			For i = 1 To dd.Length - 1
				For k = 0 To dd(i).data.Length - 1
					dd(i).data(k) = dd(i).data(k) + dd(i-1).data(k)
				Next
			Next
		End If
		If itemsMap.ContainsKey("sorted") Then
			Dim listIndexes As List = Sort(dd(0).data)	' sort first set
			For jk = 0 To dd.length - 1
				setSorted(listIndexes,dd(jk).data)
			Next
			Dim lbls As String = ""			' sort labels *********************
			Dim nLabels As Int = dd(0).Labels.Length -1
			For jk = 0 To nLabels
				Dim lsItem As ls = listIndexes.Get(jk)
				If lsItem.index <= nLabels Then lbls = lbls & "|" &  dd(0).labels(lsItem.index)
			Next
			If lbls <> "" Then dd(0).labels = Regex.Split("\|",lbls.SubString(1))
		End If
		If "PieRingVenn".Contains(chartType) Then
			canvas.DrawText(G.Title, x, 24dip, Typeface.DEFAULT_BOLD, 15, objectsColorMap.GetDefault("title",colorsMap.get("black")), align)
			listExploded.Initialize2(Regex.Split(reSpaceOrComma,getItem("explode","")))
			If chartType = "Ring" Then
				dd(0).color = colorsMap.Get("silver")
				If TypeOf(objectsColorMap.Get("chart")) = "Integer" Then dd(0).color = objectsColorMap.Get("chart")	' internal ring color			
			End If
			dd(0).slice = getItem("slice","360")	' slice possible for ring and pie charts
			dd(0).maxLabelWidth = getMaxLabelWidth(dd(0).labels,13)	' compute legend label occupation
		Else
			If "ScatterMap".Contains(chartType) Then
				setLimits(dd(0))				
				Dim aScatterLabels(11) As String
				Dim Delta As Float = 0.1 *(dd(0).Maximum - dd(0).Minimum)
				For j = 0 To 10
					aScatterLabels(j) = dd(0).Minimum + J * Delta
				Next
				dd(0).labels =  aScatterLabels			
			End If
			dd(0).maxLabelWidth = getMaxLabelWidth(dataNames,13)	' compute data description occupation
			dd(0).maxDataLabelWidth = getMaxLabelWidth(dd(0).labels,12)	' compute label occupation
			If Not(existsAxis) Then
				canvas.DrawText(G.Title, x, 24dip, Typeface.DEFAULT_BOLD, 15, objectsColorMap.GetDefault("title",colorsMap.get("black")), align)
				If itemData.chartType.Contains("bar") And Minimum > 0 Then Minimum = 0
				Dim Yinterval As Double = (Maximum - Minimum) * 0.1
				Dim numericLabels((Maximum - Minimum) / Yinterval + 1) As Float	' array of Y labels
				For i=0 To numericLabels.Length - 1	' create numeric labels
					numericLabels(i) = Minimum + Yinterval * i
				Next
				If chartType <> "Map" Then existsAxis = drawAxis(dd(0))
			End If
		End If
		For jk = 1 To dd.length - 1
			dd(jk).maxLabelWidth = dd(0).maxLabelWidth
			dd(jk).intervalX = dd(0).intervalX
		Next
		Select chartType
			Case "Area"
				drawArea(dd)
			Case "Bar", "Areabar"
				If itemsMap.ContainsKey("stacked") Then 
					drawSBar(dd)
				Else 
					drawBar(dd)
				End If
			Case "Bubble"
				drawBubble(dd)
			Case "Delta"
				drawDelta(dd)
			Case "Hbar"
				drawHBar(dd)
			Case "Line"
				drawLine(dd)
			Case "Pie","Ring"
				drawPie(dd)
			Case "Point"
				drawPoint(dd)
			Case "Map"
				drawMap(dd)
			Case "Scatter"
				drawScatter(dd)
			Case "Venn"
				drawVenn(dd)
		End Select
	Next	
	target.Invalidate
	Return
End Sub
private Sub drawAxis(itemdata As data) As Boolean
	If itemdata.chartType <> "hbar" Then
		canvas.DrawLine(GI.originX-1dip, GI.originY+5dip, GI.originX-1dip, GI.maxY - 2dip, G.yAxisColor, 2dip)	' Draw Y axis
		For i = 0 To numericLabels.Length - 1
				Dim y As Int = calcPointToPixel(numericLabels(i), G)
				canvas.DrawLine(GI.originX-5dip, y, GI.originX + GI.gw, y, ReduceTransparent(G.xAxisColor,2), 1dip)
				canvas.DrawText(NumberFormat(numericLabels(i),1,2), GI.originX - 8dip, y + 5dip,Typeface.DEFAULT, 12, G.yAxisLabelColor, "RIGHT")
		Next
	End If
	' Draw axis labels --------------------------------------------------------------------------------------
	canvas.DrawText(G.XAxis, target.Width / 2, GI.originY+38dip, Typeface.DEFAULT, 14, G.xAxisLabelColor, "CENTER")
	canvas.DrawTextRotated(G.YAxis, 16dip, target.Height / 2, Typeface.DEFAULT, 14, G.yAxisLabelColor, "CENTER", -90)
	canvas.DrawLine(GI.originX-5dip, GI.originY, GI.originX + GI.gw+2dip, GI.originY, G.xAxisColor, 2dip) ' Draw X axis
	' Draw vertical labels and x lines -----------------------------------------------------------------------
	Dim nVerticalLines As Int = 20	' compute number of vertical lines
	If itemdata.chartType = "scatter" Then 
		nVerticalLines = 10
	Else
		If itemdata.data.Length <= 20 Then
			nVerticalLines = itemdata.data.Length
			If Not(chartPoints.ContainsKey(itemdata.chartType)) Then nVerticalLines = nVerticalLines - 1
		End If
	End If
	Dim xIncrement As Float = GI.gw / nVerticalLines
	If itemdata.chartType <> "bar" And itemdata.chartType <> "areabar" And itemdata.chartType <> "hbar" Then	' no vertical lines for bar
		For i= 0 To nVerticalLines -1
			Dim x1 As Float = GI.originX+xIncrement + i * xIncrement
			canvas.DrawLine(x1, GI.originY+5dip, x1, GI.maxY - 2dip, ReduceTransparent(G.yAxisColor,2), 1dip)
		Next
	End If
	Return True
End Sub
private Sub drawBar(itemdata() As data)
	Dim Intervalx As Int = itemdata(0).intervalX	' set Bar Interval
	Dim overlap As Float = getItem("overlap","0")/100
	Dim barsWidth As Int = 0.9*Intervalx/(itemdata.Length-(itemdata.Length-1)*overlap)	' Bar width
	If itemdata(0).chartType = "areabar" Then barsWidth = Intervalx/itemdata.Length	' area bar
	Dim baseBar As Int = G.GI.originY-1dip
	If Minimum < 0 And Maximum > 0 Then baseBar = calcPointToPixel(0, G)	
	For k = 0 To itemdata.Length - 1
		Dim offsetBar As Int = 1dip+barsWidth * k * (1 - overlap)
		For i = 0 To itemdata(k).data.Length - 1
			If itemdata(k).hasData(i) Then
				Dim Rect As Rect
				Dim leftRect As Int = G.GI.originX + Intervalx * i + offsetBar
				Rect.Initialize(leftRect, 0, leftRect + barsWidth, baseBar)
				Rect.Top = calcPointToPixel(itemdata(k).data(i), G)
				Dim color As Int = itemdata(k).color
				If itemdata(k).data(i) < 0 Then color = itemdata(k).color2
				canvas.DrawRect(Rect, color, True, 1dip)
				canvas.DrawText(itemdata(k).data(i), leftRect+0.5*barsWidth, Rect.Top-5dip*Sign(itemdata(k).data(i)), Typeface.DEFAULT, 10, color, "CENTER")
			End If
			If k = 0 Then drawLabel(itemdata(0),G.GI.originX + Intervalx * (0.5 + i),GI.originY + 15dip,i)
		Next
		drawLegend(itemdata(k))
	Next
End Sub
private Sub drawHBar(itemdata() As data)	' horizontal bars *********************************
	Dim IntervalY As Float = Min(30dip,G.GI.gh / itemdata(0).data.Length)	' set Bar Interval
	Dim baseBar As Int = G.GI.originX + itemdata(0).maxDataLabelWidth
	Dim offset0 As Int = baseBar
	If Minimum < 0 And Maximum > 0 Then offset0 = baseBar - (G.GI.gw - itemdata(0).maxDataLabelWidth) * Minimum / (Maximum - Minimum)
	Dim xIncrement As Float = (G.GI.gw - itemdata(0).maxDataLabelWidth)/(numericLabels.Length - 1)
	Dim yBarPosition As Int = G.GI.maxY + G.GI.gh - 0.1 * IntervalY
	For i = itemdata(0).data.Length - 1 To 0 Step - 1
		Dim Rect As Rect
		Dim barWidth As Int =  (itemdata(0).data(i)) * (GI.gw - itemdata(0).maxDataLabelWidth)/ (Maximum - Minimum)
		Rect.Initialize(offset0, yBarPosition, offset0 + barWidth, yBarPosition - 0.9*IntervalY)
		Dim color As Int = itemdata(0).color
		If itemdata(0).data(i) < 0 Then color = itemdata(0).color2
		canvas.DrawRect(Rect, color, True, 1dip)
		If i < itemdata(0).labels.Length Then canvas.DrawText(itemdata(0).labels(i), G.GI.originX -10dip, yBarPosition - 0.4*IntervalY, Typeface.DEFAULT, 12, G.yAxisLabelColor, "LEFT")
		If itemdata(0).data(i) < 0 Then canvas.DrawText(itemdata(0).data(i), Rect.right-5dip, yBarPosition-0.4*IntervalY, Typeface.DEFAULT, 10, color, "RIGHT")
		If itemdata(0).data(i) >= 0 Then canvas.DrawText(itemdata(0).data(i), Rect.right+5dip, yBarPosition-0.4*IntervalY, Typeface.DEFAULT, 10, color, "LEFT")
		yBarPosition = yBarPosition - IntervalY
	Next
	For i = 0 To numericLabels.Length - 1	'x axis labels
		canvas.DrawText(numericLabels(i),baseBar+i*xIncrement,GI.originY+10dip,Typeface.DEFAULT,12,G.xAxisLabelColor,"CENTER")
	Next
	drawLegend(itemdata(0))
End Sub
private Sub drawSBar(itemdata() As data)	' stacked bars *********************************
	Dim Intervalx As Int = itemdata(0).intervalX	' set Bar Interval
	Dim barsWidth As Int = 0.9 * Intervalx	' Bar width
	Dim Rect As Rect
	For i = 0 To itemdata(0).data.Length - 1
		Dim baseBar As Int = G.GI.originY-1dip
		For k = 0 To itemdata.Length - 1
			Dim value As Float = itemdata(k).data(i)
			If k > 0 Then 
				value = value - itemdata(k-1).data(i)
				baseBar = calcPointToPixel(itemdata(k-1).data(i), G)
			End If
			Dim leftRect As Int = G.GI.originX + Intervalx * i
			Rect.Initialize(leftRect, 0, leftRect + barsWidth, baseBar)
			Rect.Top = calcPointToPixel(itemdata(k).data(i), G)
			canvas.DrawRect(Rect, itemdata(k).color, True, 1dip)
			drawLabel(itemdata(0),G.GI.originX + Intervalx * (0.5 + i),GI.originY + 15dip,i)
			If i = 0 Then drawLegend(itemdata(k))
		Next
	Next
End Sub

private Sub drawArea( itemdata() As data)
	For k = 0 To itemdata.Length - 1
		If k = 0 Then
			areaPointsMap.Put("bottom",Array As Float(Minimum,Minimum))
		Else
			areaPointsMap.Put("bottom",areaPointsMap.Get("top"))
		End If
		areaPointsMap.Put("top",itemdata(k).data)
		Dim Intervalx As Float = itemdata(k).intervalX	' Interval
		Dim bottomPoints() As Float = areaPointsMap.Get("bottom")
		Dim bottomIntervalx As Int = GI.gw/(bottomPoints.Length-1)	' Interval of base line
		Dim Path As Path
		Path.Initialize(GI.gw,calcPointToPixel(bottomPoints(bottomPoints.length-1),G))	' start at right
		For i = bottomPoints.length - 1 To 0 Step - 1
			Path.LineTo(GI.originX+i*bottomIntervalx,calcPointToPixel(bottomPoints(i),G))
		Next
		For i = 0 To itemdata(k).data.Length - 1
			Dim x As Int = GI.originX + i * Intervalx
			Path.LineTo(x,calcPointToPixel(itemdata(k).data(i),G))
			If k = 0 Then drawLabel(itemdata(0),x,GI.originY + 15dip,i)
		Next
		Dim destRect As Rect
		Path.LineTo(x,calcPointToPixel(bottomPoints(bottomPoints.Length-1),G))
		destRect.Initialize(GI.originX,GI.originY,GI.gw,GI.gh)
		canvas.ClipPath(Path) 'clip the drawing area to the path
		canvas.DrawColor(itemdata(k).color)
		canvas.RemoveClip
		drawLegend(itemdata(k))
	Next
End Sub
Sub drawBubble(itemdata() As data)
	If itemdata.Length < 2 Then	' no bubble!
		drawPoint(itemdata)
		Return
	End If
	Dim Intervalx As Float = itemdata(0).intervalX	' Interval
	Dim rMod As Float = 0.5*Intervalx/(itemdata(1).Maximum-itemdata(1).Minimum)	' radius modificator
	Dim x As Int = GI.originX + Intervalx
	For i = 0 To itemdata(0).data.Length - 1
		Dim bubbleRadius As Float = 4dip+rMod*(itemdata(1).data(i)-itemdata(1).Minimum)
		canvas.drawCircle(x,calcPointToPixel(itemdata(0).data(i),G),bubbleRadius,itemdata(1).color,True,1dip)
		canvas.Drawcircle(x,calcPointToPixel(itemdata(0).data(i),G),1dip,itemdata(0).color,True,1dip)
		canvas.DrawText(itemdata(1).data(i), x, calcPointToPixel(itemdata(0).data(i),G)+bubbleRadius+12dip, Typeface.DEFAULT,12,itemdata(1).color, "CENTER")
		drawLabel(itemdata(0),x,GI.originY + 15dip,i)
		x = x + Intervalx
	Next	
	drawLegend(itemdata(0))
	drawLegend(itemdata(1))
End Sub
private Sub drawDelta(itemdata() As data)
	If itemdata.Length < 2 Then Return	' no delta!
	Dim Intervalx As Float = itemdata(0).intervalX
	Dim x As Int = GI.originX + Intervalx
	For i = 0 To itemdata(0).data.Length - 1
		Dim color As Int = itemdata(0).color
		If itemdata(0).data(i) > itemdata(1).data(i) Then color = itemdata(1).color
		canvas.DrawLine(x, calcPointToPixel(itemdata(0).data(i), G), _
						x , calcPointToPixel(itemdata(1).data(i), G), color, 2dip)
		If itemdata(0).data(i) = itemdata(1).data(i) Then canvas.drawCircle(x,calcPointToPixel(itemdata(0).data(i),G),2dip,itemdata(1).color,True,1dip)
		drawLabel(itemdata(0),x,GI.originY + 15dip,i)
		x = x + Intervalx
	Next
	drawLegend(itemdata(0))
	drawLegend(itemdata(1))
End Sub
private Sub drawLine(itemdata() As data)
	Dim Intervalx As Float = itemdata(0).intervalX	' Interval
	For k = 0 To itemdata.Length - 1
		pointsList.initialize
		Dim points(itemdata(k).data.Length) As CubicSlpanePoint
		For i = 0 To itemdata(k).data.Length - 1
			points(i).X = GI.originX + i * Intervalx
			points(i).Y = calcPointToPixel(itemdata(k).data(i), G)
		Next
		If itemsMap.ContainsKey("smooth") Then
			SetPandU(points)
			Dim xPos As Int
			Dim yPos As Int
			For piece = 0 To points.Length - 2
				For xPos = points(piece).x To points(piece + 1).x
					yPos = getCurvePoint(points,piece, xPos)
					canvas.DrawCircle(xPos, yPos,1dip,itemdata(k).color,True,1dip)
				Next
			Next
		Else
			For i = 0 To itemdata(k).data.Length - 2
				If itemdata(k).hasData(i+1) Then
					If itemdata(k).hasData(i) Then canvas.DrawLine(points(i).X, points(i).Y,points(i+1).X , points(i+1).Y, itemdata(k).color, 2dip)
				End If
			Next
		End If
		If k = 0 Then	' point labels
			For i = 0 To itemdata(k).data.Length - 1
				drawLabel(itemdata(0),points(i).X,GI.originY + 15dip,i)
			Next
		End If
		drawLegend(itemdata(k))
	Next
End Sub
private Sub drawMap(itemdata() As data)
	If itemdata.Length < 2 Then Return' Scatter needs 2 sets of data
	If itemdata.Length = 3 Then	' scatter bubble
		Dim rMod As Float = 20/(itemdata(2).Maximum-itemdata(2).Minimum)	' radius modificator
	End If
	Dim Inferior As Float = itemdata(0).Minimum
	Dim Delta As Float = itemdata(0).Maximum - Inferior
	For i = 0 To itemdata(0).data.Length - 1
		Dim x As Int = G.GI.originX + (itemdata(0).data(i) - Inferior) * GI.gw / Delta
		Dim y As Int = G.GI.originY - G.GI.gh * (itemdata(1).data(i) - Minimum)/(Maximum-Minimum)
		Dim bubbleRadius As Float = 2dip
		If itemdata.Length = 3 Then
			bubbleRadius = 4dip+rMod*(itemdata(2).data(i)-itemdata(2).Minimum)
			canvas.DrawText(toText("%4.1",Array As Object(itemdata(2).data(i))), x, y+bubbleRadius+12dip, Typeface.DEFAULT,12,itemdata(0).color, "CENTER")
			If i < Labels.Length Then canvas.DrawText(Labels(i),x,y,Typeface.DEFAULT,12,objectsColorMap.get("label_xaxis"), "CENTER")
		End If
		canvas.drawCircle(x,y,bubbleRadius,itemdata(0).color,True,1dip)	' there is only one color
	Next
	If itemdata.Length = 3 Then drawLegend(itemdata(0))
End Sub
private Sub drawPie(itemdata() As data)
	Dim ringColor As Int = itemdata(0).color	' is the ground color
	Dim total As Float = 0
	Dim Theta As Float = -180 	' slice angle
	For i = 0 To itemdata(0).data.Length - 1
		total = total + itemdata(0).data(i)
	Next
	For i = 0 To itemdata(0).data.Length - 1
		itemdata(0).color = getColor(i)
		Dim center() As Int = Array As Int(0.45 * canvas.Bitmap.Width,0.60 * canvas.Bitmap.Height)
		If getItem("slice",360) < 181 Then center(1) = 0.75 * canvas.Bitmap.Height
		Dim sliceAngle As Float = itemdata(0).slice * itemdata(0).data(i)/total
		Dim radius As Int = 0.35*(Min(canvas.Bitmap.Width,canvas.Bitmap.Height))
		If itemdata.Length > 1 Then radius = 0.60 * radius ' radar pie
		Dim explode As Int = 0
		If listExploded.IndexOf(NumberFormat(i+1,0,0)) > -1 Then explode = 10dip
		Dim realRadius As Int = radius
		If itemdata.Length > 1 Then realRadius = radius + 0.4*radius* itemdata(1).data(i)/itemdata(1).Maximum
		drawSlice(center, realRadius, Theta, sliceAngle,itemdata(0).color, explode)
		Dim textPosition As Int = center(0)+(realRadius+explode+15dip)*CosD(Theta+0.5*sliceAngle)
		Dim a() As String = showDatum(itemdata(0).data(i),total)
		If a(0) <> "" Then 
			canvas.DrawText(a(0),textPosition,center(1)+(realRadius+15dip+explode)*SinD(Theta+0.5*sliceAngle),Typeface.DEFAULT_BOLD,10,itemdata(0).color,"CENTER")
		End If
		If a(1) <> "" Then 
			textPosition = center(0)+(realRadius+explode-15dip)*CosD(Theta+0.5*sliceAngle)
			canvas.DrawText(a(1),textPosition,center(1)+(realRadius-15dip+explode)*SinD(Theta+0.5*sliceAngle),Typeface.DEFAULT_BOLD,10,invertColor(itemdata(0).color),"CENTER")
		End If
		If i < itemdata(0).labels.Length Then
			itemdata(0).labels(i) = itemdata(0).labels(i).Replace("%v",itemdata(0).data(i))
			itemdata(0).labels(i) = itemdata(0).labels(i).Replace("%",toText("%4.1%",Array As Object(100 * itemdata(0).data(i)/total)))
			drawLegend(itemdata(0))
		End If
		Theta = Theta + sliceAngle
	Next
	If itemdata(0).chartType = "ring" Then
		canvas.DrawCircle(center(0),center(1),0.2*(GI.gw),ringColor,True,1dip)
	End If
	canvas.DrawText(itemdata(0).name, 0.45*canvas.Bitmap.Width, canvas.Bitmap.Height - 15dip,Typeface.DEFAULT, 14, G.xAxisLabelColor, "CENTER")
End Sub	' drawPie
private Sub drawPoint(itemdata() As data)
	Dim Intervalx As Float = itemdata(0).intervalX	' Interval
	Dim originX As Float = GI.originX + Intervalx
	For k = 0 To itemdata.Length - 1
		For i = 0 To itemdata(k).data.Length - 1
			If itemdata(k).hasData(i) Then
				canvas.drawCircle(originX + Intervalx * i,calcPointToPixel(itemdata(k).data(i),G),3dip,itemdata(k).color,True,1dip)
			End If
			If k = 0 Then drawLabel(itemdata(0),originX + Intervalx * i,GI.originY + 15dip,i)
		Next
		drawLegend(itemdata(k))
	Next
End Sub
Sub drawLabel(itemdata As data,x As Int,y As Int,index As Int)
	If itemdata.labels.Length = 0 Then Return
	Dim labelsEvery As Int = Max(1,itemdata.data.Length/(itemdata.labels.Length-1))	' test if few labels
	If index/labelsEvery < itemdata.labels.Length Then
		If index Mod labelsEvery = 0 Then
			Dim textOrientation As Int = 0
			If itemdata.maxDataLabelWidth > itemdata.intervalX * labelsEvery Then textOrientation = -45
			canvas.DrawTextRotated(itemdata.labels(index/labelsEvery), x, y, Typeface.DEFAULT, 12, G.xAxisLabelColor, "CENTER", textOrientation)
		End If
	End If
End Sub
private Sub drawScatter(itemdata() As data)
	If itemdata.Length < 2 Then Return' Scatter needs 2 sets of data
	If itemdata.Length = 3 Then	' scatter bubble
		Dim rMod As Float = 20/(Max((itemdata(2).Maximum-itemdata(2).Minimum),20))	' radius modificator
	End If
	Dim Inferior As Float = itemdata(0).Minimum
	Dim Delta As Float = itemdata(0).Maximum - Inferior
	For i = 0 To itemdata(0).data.Length - 1
		Dim x As Int = G.GI.originX + (itemdata(0).data(i) - Inferior) * GI.gw / Delta
		Dim y As Int = G.GI.originY - G.GI.gh * (itemdata(1).data(i) - Minimum)/(Maximum-Minimum)
		Dim bubbleRadius As Float = 2dip
		If itemdata.Length = 3 And itemdata(2).hasData(i) Then
			bubbleRadius = 4dip+rMod*(itemdata(2).data(i)-itemdata(2).Minimum)
			canvas.DrawText(itemdata(2).data(i), x, y+bubbleRadius+12dip, Typeface.DEFAULT,12,itemdata(0).color, "CENTER")
		End If
		canvas.drawCircle(x,y,bubbleRadius,itemdata(0).color,True,1dip)	' there is only one color
	Next
	
	Dim xIncrement As Float = G.GI.gw/(itemdata(0).labels.Length - 1)
	For i = 0 To itemdata(0).labels.Length - 1
		drawLabel(itemdata(0),G.GI.originX+i*xIncrement,GI.originY + 15dip,i)
	Next
	If itemdata.Length = 3 Then
		drawLegend(itemdata(0))
	End If
End Sub
private Sub drawVenn(itemdata() As data)
	Dim VennData(3) As Float
	If itemdata(0).data.Length < 2 Then 
		canvas.DrawText("Venn diagram needs two or three items",100dip,80dip,Typeface.DEFAULT, 14,Colors.Red,"LEFT")
		Return' Venn needs 3 items: Set1, Set2 and their intersection
	End If
	VennData(0) = itemdata(0).data(0)
	VennData(1) = itemdata(0).data(1)
	VennData(2) = Min(itemdata(0).data(0),itemdata(0).data(1))
	If itemdata(0).data.Length = 3 Then VennData(2) = itemdata(0).data(2)
	If VennData(2) > Min(itemdata(0).data(0),itemdata(0).data(1)) Then	' inconsistent
		canvas.DrawText("Intersection set inconsistent",100dip,80dip,Typeface.DEFAULT, 14,Colors.Red,"LEFT")	
		Return
	End If
	Dim pGrec As Float = 3.14159
	Dim r1 As Float = Sqrt(VennData(0)/pGrec)
	Dim r2 As Float = Sqrt(VennData(1)/pGrec)
	' compute radius distance based on intersection area i.e. itemdata.data(2)
	Dim a(2) As Float = Array As Float(-1,0)	' -1 intercept empty intersection
	If VennData(2) = Min(VennData(0),VennData(1)) Then
		Dim d As Float = Max(r1,r2) - Min(r1,r2)	' a set included
		a(1) = r1
		If r1 < r2 Then a(1) = -r1
	Else
		Dim intersectArea As Float = VennData(2)
		Dim x1 As Float = r1+r2						' at end contains the distance
		Dim x2 As Float = Abs(r1-r2)
		Do While Abs(intersectArea - a(0)) > 0.001
			Dim d As Float = 0.5*(x1+x2)
			a = areaOfIntersection(r1,d, r2)		' returns area and ascissa of intersection of circles
			If a(0) < intersectArea Then  x1 = d	' the distance must be decreased
			If a(0) >= intersectArea Then x2 = d	' the distance must be augmented"
		Loop
	End If
	For i=0 To itemdata(0).labels.Length -1
		itemdata(0).labels(i) = itemdata(0).labels(i).Replace("%v",VennData(i))
	Next
	Dim p As Float = GI.gw/(r1+r2+d)	' proportionality factor
	If  p * (Max(r1,r2)) > 0.4*GI.gh Then p = 0.8 * p
	Dim VennWidth As Float = p * (r1+r2+d)
	Dim VennLeft As Float = 0.5*GI.originX+0.5*(GI.gw - VennWidth)
	Dim VennHCenter As Float = 60dip+0.5*GI.gh
	canvas.DrawCircle(VennLeft+p*r1,VennHCenter,p*r1,itemdata(0).color,True,1dip)		' first circle
	drawLegend(itemdata(0))
	itemdata(0).color = getColor(1)
	canvas.DrawCircle(VennLeft+p*(r1+d),VennHCenter,p*r2,itemdata(0).color,True,1dip)	' second circle
	canvas.DrawText(itemdata(0).name, 0.5*canvas.Bitmap.Width, canvas.Bitmap.Height - 15dip,Typeface.DEFAULT, 14, G.xAxisLabelColor, "CENTER")
	drawLegend(itemdata(0))	
' create intersection area *****
	If itemdata(0).data.Length = 3 Then
		itemdata(0).color = getColor(2)	' intersection color
		Dim pth As Path = createPath(Array As Float(VennLeft+p*(r1+a(1)),canvas.bitmap.height,VennLeft+p*(r1+a(1)),0,canvas.bitmap.width,0,canvas.bitmap.width,canvas.bitmap.height))
		canvas.ClipPath(pth)
		canvas.DrawCircle(VennLeft+p*r1,VennHCenter,p*r1,itemdata(0).color,True,1dip)
		canvas.RemoveClip
		pth = createPath(Array As Float(0,0,0,canvas.bitmap.height,VennLeft+p*(r1+a(1)),canvas.bitmap.height,VennLeft+p*(r1+a(1)),0))
		canvas.ClipPath(pth)
		itemdata(0).color = getColor(2)
		canvas.DrawCircle(VennLeft+p*(r1+d),VennHCenter,p*r2,itemdata(0).color,True,1dip)
		canvas.RemoveClip
		drawLegend(itemdata(0))
	End If
End Sub
private Sub showDatum(datum As String, total As Float) As String()
	Dim a(2) As String = Array As String("","")
	a(0) = getItem("show","%").Replace("%v",datum)
	a(0) = a(0).Replace("%",toText("%4.1%",Array As Object(100 * datum/total)))
	a(1) = getItem("inside","").Replace("%v",datum)
	a(1) =a(1).Replace("%",toText("%4.1%",Array As Object(100 * datum/total)))
	Return a
End Sub
private Sub areaOfIntersection(r1 As Float, d As Float, r2 As Float) As Float() 
	' first circle is on origin, all center are on abscisse returns area and center of intersection of circles
	Dim rr1 As Float = r1 * r1
	Dim rr2 As Float = r2 * r2
	Dim d2 As Float = d * d
	Dim phi As Float = 2 * (ACos((rr1 + d2 - rr2) / (2 * r1 * d)))	' cos(α) = (a2+b2-c2)/(2*a*b)
	Dim theta As Float = 2 * (ACos((rr2 + d2 - rr1) / (2 * r2 * d)))
	Dim a(2) As Float
	a(0) = 0.5 * (rr1 * (phi - Sin(phi)) + rr2 * (theta - Sin(theta)))
	a(1) = r1 * Cos(phi * 0.5)	' center of intersection
	Return a
End Sub
Sub drawLegend(itemdata As data)
	If Bit.And(itemdata.color,0xFF000000) = 0 Then Return '	no legend if transparent
	Dim y As Float = legendPosition * 15dip + headerHeight + 15dip
	Dim x As Float = canvas.Bitmap.Width - itemdata.maxLabelWidth -20dip
	Dim beforeText As String = " "
	Select itemdata.chartType
		Case "area"
			beforeText = Chr(9699)	' Unicode triangle
			canvas.DrawText(Chr(9698), x, y,Typeface.DEFAULT, 13, itemdata.Color, "LEFT")
		Case "bar","areabar","hbar"
			beforeText = Chr(9600)	' upper half block
			canvas.DrawText(Chr(9604), x, y,Typeface.DEFAULT, 13, itemdata.Color2, "LEFT")
		Case "bubble","point","venn","scatter","map"
			beforeText = Chr(9679)	' Unicode circle
		Case "delta"
		Case "pie"
			canvas.DrawText(Chr(9684), x, y,Typeface.DEFAULT, 14, itemdata.Color, "LEFT") ' Unicode circle slice
		Case "ring"
			'			canvas.DrawText("O ", x, y,Typeface.DEFAULT_BOLD, 13, itemdata.Color, "LEFT")
		Case Else
			beforeText = Chr(9644)	' Unicode line
	End Select
	If "pieringvenn".Contains(itemdata.chartType) Then
		If itemdata.labels(legendPosition) <> "" Then canvas.DrawText(beforeText & "  " & itemdata.labels(legendPosition), x, y,Typeface.DEFAULT, 13, itemdata.Color, "LEFT")
	Else
		If itemdata.name <> "" Then canvas.DrawText(beforeText & " " & itemdata.name, x, y,Typeface.DEFAULT, 13, itemdata.Color, "LEFT")
	End If
	legendPosition = legendPosition + 1
End Sub
Sub getMaxLabelWidth(lbl() As String,txtSize As Int) As Float
	Dim maxWidth As Float = 0
	For i = 0 To lbl.Length - 1
		maxWidth = Max(canvas.MeasureStringWidth(lbl(i),Typeface.DEFAULT,txtSize),maxWidth)
	Next
	Return maxWidth
End Sub
Sub calcPointToPixel(py As Float, Graph As Graph) As Int
	Return Graph.GI.originY - Graph.GI.gh * (py - Minimum)/(Maximum-Minimum)
End Sub
'Draws a single slice
Sub drawSlice(center() As Int, Radius As Int, startDegree As Float, sliceAngle As Float, Color As Int, explode As Int) 
	Dim cx As Int = center(0)
	Dim cy As Int = center(1)
	' explode contains 0 or 10dip if the slice must be exploded
	cx = cx + explode * CosD(startDegree+0.5*sliceAngle)
	cy = cy + explode * SinD(startDegree+0.5*sliceAngle)
	Dim p As Path
	Do While sliceAngle > 0
		Dim slDg As Float = 72
		If slDg > sliceAngle Then slDg = sliceAngle
		p.Initialize(cx, cy)
		p.LineTo(cx+Radius*CosD(startDegree),cy+Radius*SinD(startDegree))
		Dim ip As Float = Radius*Sqrt(1+TanD(slDg)*TanD(slDg))	' hypotenuse
		p.LineTo(cx+ip*CosD(slDg+startDegree),cy+ip*SinD(slDg+startDegree))
		p.lineTo(cx, cy)
		canvas.ClipPath(p)
		canvas.DrawCircle(cx, cy, Radius, Color, True, 0)
		canvas.RemoveClip
		sliceAngle = sliceAngle - slDg
		startDegree = startDegree + slDg
	Loop
End Sub
Sub createPath(points() As Float) As Path	' create paths, it is closed by the first couple
	Dim p As Path
	p.Initialize(points(0), points(1))
	For i = 2 To points.length - 2 Step 2
		p.lineTo(points(i), points(i+1))
	Next
	p.LineTo(points(0), points(1))
	Return p
End Sub
Sub replace(s As String) As String
	Dim Mtch As Matcher = Regex.Matcher(reExtractPlaceholders,s)
	Do While Mtch.Find	' placeholder chart, date
		If replacerMap.Containskey(Mtch.Match.ToLowerCase) Then
			s = s.Replace(Mtch.match,replacerMap.get(Mtch.Match.ToLowerCase))
		Else if IsNumber(Mtch.Match.SubString(1)) Then
			s = s.Replace(Mtch.Match,Chr(Mtch.Match.SubString(1)))	' Unicode and special chracters
		Else
			Dim aSplits() As String = Regex.Split("\(|\)|\s+",Mtch.Match)	' splits in future my be (n m)
			s = s.Replace(aSplits(0),monthsDaysLabels(aSplits(0).ToLowerCase))
		End If
	Loop
	Return s
End Sub
Sub list2Array(lst As List) As String()
	Dim r(lst.Size) As String
	For i = 0 To lst.Size - 1
		r(i) = lst.Get(i)
	Next
	Return r
End Sub
Sub getDataArray(a() As String) As String(,)	' this create an array (n,m) where
												' n is set number and m is the maximun of sets length
	Dim numCols As Int = 1
	For i = 0 To a.Length - 1
		Dim a1() As String = getItems(a(i).Trim,reSepareNumericTokens)
		If a1.Length > numCols Then numCols = a1.Length
	Next
	Dim r(a.Length,numCols) As String
	For i = 0 To a.Length - 1
		a1 = getItems(a(i).Trim,reSepareNumericTokens)
		For j = 0 To numCols - 1
			If j < a1.Length Then
				r(i,j) = a1(j)
			Else
				r(i,j) = "*"
			End If
		Next
	Next
	Return r
End Sub
Sub getRow(a(,) As String, row As Int) As Float()
	Dim ref As Reflector
	Dim ranks(0) As Int
	ref.Target = a
	ranks = ref.TargetRank
	Dim r(ranks(1)) As Float
	For i=0 To ranks(1) -1
		If a(row,i) = ""  Or a(row,i) = "*" Then
'			r(i) = Null	' this doens't works
		Else
			r(i) = a(row,i)
		End If
	Next
	' ranks.Length is the number of dimensions of the array
	' rank contents are the length of the first element of each dimension
	Return r
End Sub
Sub getHasData(a(,) As String, row As Int) As Boolean()
	Dim ref As Reflector
	Dim ranks(0) As Int
	ref.Target = a
	ranks = ref.TargetRank
	Dim r(ranks(1)) As Boolean
	For i=0 To ranks(1) -1
	If a(row,i) = "" Or a(row,i) = "*" Then
			r(i) = False
		Else
			r(i) = True
		End If
	Next
	' ranks.Length is the number of dimensions of the array
	' rank contents are the length of the first element of each dimension
	Return r
End Sub
Sub removeDelimiters(s As String) As String
	If s.Length = 0 Then Return s
	If s.CharAt(0) <> "'" And s.CharAt(0) <> """" Then Return s
	Return s.SubString2(1,s.Length-1)
End Sub
Sub MakeTransparent(Color As Int, Alpha As Int) As Int
	Return Bit.Or(Bit.ShiftLeft(Alpha, 24),Bit.And(Color,0x00FFFFFF))
End Sub
Sub invertColor(Color As Int) As Int
	Dim c As Int = Bit.And(0x00FFFFFF,Bit.Not(Color))
	Return Bit.Or(Bit.And(0xFF000000,Color),c)
End Sub
Sub ReduceTransparent(Color As Int, Factor As Int) As Int	' I.E shift Factor time 14 April 2019
	Dim alpha As Int = Bit.UnsignedShiftRight(Bit.And(Color,0xFF000000),24+Factor)
	Return Bit.Or(Bit.ShiftLeft(alpha, 24),Bit.And(Color,0x00FFFFFF))
End Sub
Sub searchMinMax(itemdata As data)
	Minimum = itemdata.data(0)
	Maximum = Minimum
	For i=1 To itemdata.data.Length - 1
		If itemdata.hasData(i) Then
			If itemdata.data(i) < Minimum Then Minimum = itemdata.data(i)
			If itemdata.data(i) > Maximum Then Maximum = itemdata.data(i)
		End If
	Next
	itemdata.Minimum = Minimum
	itemdata.Maximum = Maximum
End Sub
Sub createGradient(GroundColors As List) As GradientDrawable
	Dim grad As GradientDrawable
	Dim cols(2) As Int
	If GroundColors.Size = 2  Then GroundColors.Add("TOP_BOTTOM")
	cols(0) = interpColor(GroundColors.Get(0))
	cols(1) = interpColor(GroundColors.Get(1))
	Dim direction As String = GroundColors.get(2)
	grad.Initialize(direction,cols)	' GroundColors.get(2) is not accepted
	Return grad
End Sub
Sub possibleGradient(color As String) As Object	' returns color or gradient (this last yet to translate)
	Dim listGroundColor As List
	listGroundColor.Initialize
	Dim pattern As String = "([x][0-9a-fA-F]+)|(\w+\s+\d+)|(\w+)|(TOP_BOTTOM|RIGHT_LEFT|BOTTOM_TOP|LEFT_RIGHT)"
	Dim Mtch As Matcher
	Mtch = Regex.Matcher2(pattern,Regex.CASE_INSENSITIVE,color)
	Do While Mtch.Find
		listGroundColor.Add(Mtch.Match)
	Loop
	If listGroundColor.Size = 1 Then
		Return interpColor(listGroundColor.Get(0))
	End If
	Return listGroundColor
End Sub
private Sub getColor(i As Int) As Int	' returns a color
	If i < aColors.size Then Return aColors.get(i)
	Return colorsMap.GetValueAt(i Mod colorsMap.Size)	' default color
End Sub
Public Sub splitColors(c As String) As List
	Dim Match As Matcher = Regex.Matcher(reSplitColors,c)
	Dim l1 As List
	l1.initialize
	Do While Match.Find
		l1.Add(interpColor(Match.Match))
	Loop
	Return l1
End Sub
private Sub interpColor(c As String) As Int
	Dim aColor() As String = Regex.Split("\s+",c)
	Dim color As Int = Colors.White
	If colorsMap.ContainsKey(aColor(0).ToLowerCase) Then
		Dim color As Int = colorsMap.Get(aColor(0).ToLowerCase)
		If aColor.Length = 2 Then color = MakeTransparent(color,aColor(1) Mod 256)
	Else
		If aColor(0).tolowercase.StartsWith("x") Then
			If aColor(0).Length < 8 Then aColor(0) = "xFF00000".SubString2(0,10-aColor(0).Length) & aColor(0).SubString(1)
			color = Bit.ParseInt(aColor(0).SubString(3),16)
			color = MakeTransparent(color,Bit.ParseInt(aColor(0).SubString2(1,3),16)) ' set alfa color
		End If
	End If
	Return color
End Sub
private Sub Left(s As String,l As Int) As String
	If l < s.Length Then Return s.SubString2(0,l)
	Return s
End Sub
Sub getItems(s As String, re As String) As String()	' return an array of item with removed possibly delimiters
	Dim list As List
	list.Initialize
	Dim Mtch As Matcher
	Mtch = Regex.Matcher2(re,Regex.CASE_INSENSITIVE,s)
	Do While Mtch.Find
		For i=1 To Mtch.GroupCount
			If Mtch.Group(i) <> Null Then list.Add(removeDelimiters(Mtch.Group(i)))
		Next
	Loop
	Return list2Array(list)
End Sub
Sub getItem(k As String, d As String) As String	' returns data from array possibly with default
	Dim a() As String = itemsMap.GetDefault(k,Array As String(d))
	If a.Length = 0 Then Return d
	Return a(0)
End Sub
Sub TypeOf(obj As Object) As String
	Dim t() As String = Regex.Split("\.",GetType(obj))
	Return t(2)
End Sub
Sub monthsDaysLabels(what As String) As String
	Dim memDateFormat As String = DateTime.DateFormat	' save date format
	DateTime.DateFormat = "ddMMyyyy"
	Dim dt As Long = DateTime.DateParse("01012018")	' because is sunday
	Dim x As String
	If what = "%d" Or what = "%days" Then
		DateTime.DateFormat = "EEEE"
		If what = "%d" Then DateTime.DateFormat = "EEE"
		For i= 0 To 6
			x = x  & "," & DateTime.Date(dt)
			dt = DateTime.Add (dt, 0, 0,1)
		Next
	Else If what = "%m" Or what = "%months" Then
		DateTime.DateFormat = "MMMM"
		If what = "%m" Then DateTime.DateFormat = "MMM"
		For i= 0 To 11
			x = x  & "," & DateTime.Date(dt)
			dt = DateTime.Add (dt, 0, 1,0)
		Next
	End If
	DateTime.DateFormat = memDateFormat	' restore date format
	If x.Length = 0 Then Return what	' unchanged
	Return x.SubString(1)
End Sub
Sub wImage_Click
	dlgPanel.Initialize("")
	fileName.Initialize("")
	dlgPanel.Color = Colors.ARGB(240,127,127,127)
	fileName.Text = G.Title
	fileName.TextSize = 14
	dlgPanel.AddView(fileName,90dip,20dip,190dip,40dip)
	dlgPanel.AddView(label("File name"),20dip,30dip,70dip,40dip)
	dlgPanel.AddView(button("Ok"),50dip,110dip,80dip,40dip)
	Dim cancelButton As Button = button("Cancel")
	dlgPanel.AddView(cancelButton,150dip,110dip,80dip,40dip)
	dlgPanel.AddView(label("File type"),20dip,75dip,80dip,40dip)
	dlgPanel.AddView(radiobutton("jpg",jpg),90dip,65dip,70dip,40dip)
	dlgPanel.AddView(radiobutton("png",png),170dip,65dip,70dip,40dip)
	Activity.AddView(dlgPanel,10%x,15%y,fileName.Width + fileName.Left,cancelButton.Top+60dip)
End Sub
Sub button(caption As String) As Button
	Dim btn As Button
	btn.Initialize(caption)
	btn.Text = caption
	Return btn
End Sub
Sub label(caption As String) As Label
	Dim lbl As Label
	lbl.Initialize("")
	lbl.Text = caption
	Return lbl
End Sub
Sub radiobutton(caption As String,rdb As RadioButton) As RadioButton
	rdb.Initialize("")
	rdb.Text = caption
	If caption = "png" Then rdb.Checked = True
	Return rdb
End Sub
Sub Ok_Click
	Dim fileTypeMap As Map = CreateMap("png":"PNG","jpg":"JPEG")
	Dim fileType As String = "png"
	If jpg.Checked Then fileType = "jpg"
	Dim Out As OutputStream = File.OpenOutput(File.DirDefaultExternal,fileName.Text & "." & fileType, False)	' for possibly save image
	canvas.Bitmap.WriteToStream(Out, 100, toText("%",Array As String(fileTypeMap.Get(fileType))))
	Out.Close
	Dim textWriter As TextWriter
	textWriter.Initialize(File.OpenOutput(File.DirDefaultExternal, fileName.Text & ".txt", False))
	textWriter.WriteLine(chartParams)
	textWriter.Close
	ToastMessageShow("Saved",False)
	dlgPanel.RemoveView
End Sub
Sub Cancel_Click
	dlgPanel.RemoveView
End Sub
Sub GraphClose_click
	chartParams = ""
	Activity.Finish
	StartActivity(Main)
End Sub
Sub toText(msk As String, values() As Object) As String
	Dim k,j=0 As Int
	Dim str As String
	Dim mtc As Matcher
	Dim strMatch As String = "%\d{0,2}\.\d|%\d{0,2}"	' accept % %n %nn %nn.n
	Dim editFormat() As String
	mtc = Regex.Matcher(strMatch,msk)
	Do While mtc.Find = True
		k = msk.IndexOf(mtc.Match)
		If j < values.Length Then
			editFormat = Regex.Split("\.","0" & mtc.Match.SubString(1) & ".0.0")
			Select TypeOf(values(j))
				Case "Integer","Double"
					str = NumberFormat2(values(j),0,editFormat(1),editFormat(1),True)
					If editFormat(0) > 0 Then str = Right(fillString(editFormat(0)) & str,editFormat(0))
				Case Else
					str = values(j)
					If editFormat(0) > 0 Then str = Left(values(j) & fillString(editFormat(0)),editFormat(0))
			End Select
			msk = Left(msk,k) & str & msk.SubString(k+mtc.Match.Length)
		End If
		j = j+1
	Loop
	Return msk
End Sub
Sub Right(s As String,l As Int) As String
	If l < s.Length Then Return s.SubString(s.Length-l)
	Return s
End Sub
Private Sub fillString(n As Int) As String
	Dim str As String = ""
	For i=0 To n Step 10
		str = str & "          "
	Next
	Return Left(str,n)
End Sub
private Sub Sign(n As Float) As Int		' Sign function return -2 for negative or zero (for draw text)
	If n > 0 Then Return 1
	Return -2
End Sub
Sub getCurvePoint(point() As CubicSlpanePoint,i As Int, v As Float) As Float
	Dim t As Float
	'derived curve equation (which uses p's and u's for coefficients)
	t = (v - point(i).x) / point(i).u
	Return t * point(i + 1).y + (1 - t) * point(i).y + point(i).u * point(i).u * (f(t) * point(i + 1).p + f(1 - t) * point(i).p) / point.Length
End Sub

Sub F(x As Float) As Float
	Return x * x * x - x
End Sub
Private Sub SetPandU(point() As CubicSlpanePoint)
	Dim i As Int
	Dim d(point.Length) As Float
	Dim w(point.Length) As Float
	'Routine to compute the parameters of our cubic spline.  Based on equations derived from some basic facts...
	'Each segment must be a cubic polynomial.  Curve segments must have equal first and second derivatives
	'at knots they share.  General algorithm taken from a book which has long since been lost.
	'The math that derived this stuff is pretty messy...  expressions are isolated and put into
	'arrays.  we're essentially trying to find the values of the second derivative of each polynomial
	'at each knot within the curve.  That's why theres only N-2 p's (where N is # points).
	'later, we use the p's and u's to calculate curve points...

	For i = 1 To point.Length - 2
		d(i) = 2 * (point(i + 1).x - point(i - 1).x)
	Next
	For i = 0 To point.Length - 2
		point(i).u = point(i + 1).x - point(i).x
	Next
	For i = 1 To point.Length - 2
		w(i) = 6 * ((point(i + 1).y - point(i).y) / point(i).u - (point(i).y - point(i - 1).y) / point(i - 1).u)
	Next
	For i = 1 To point.Length - 3
		w(i + 1) = w(i + 1) - w(i) * point(i).u / d(i)
		d(i + 1) = d(i + 1) - point(i).u * point(i).u / d(i)
	Next
	point(1).p = 0
	For i = point.Length - 2 To 1 Step -1
		point(i).p = (w(i) - point(i).u * point(i + 1).p) / d(i)
	Next
	point(point.Length-1).p = 0
End Sub
Sub Sort(a() As Float) As List	' returns a list of ordered items
	Dim l As List
	l.Initialize
	For i=0 To a.Length - 1
		Dim lSort As ls
		lSort.s = a(i)
		lSort.index = i
		l.Add(lSort)
	Next
	l.SortType("s",True)
	Return l
End Sub
Sub setSorted(l As List,a() As Float)	' returns a object of ordered items
	For i=0 To l.Size - 1	' copy values in list
		Dim s As ls
		s  = l.get(i)
		s.s = a(s.index)
		l.Set(i,s)
	Next
	For i=0 To l.Size - 1
		s  = l.get(i)
		a(i) = s.s
	Next
End Sub
Sub lLimit(v As Float) As Float
	If v < 0 Then Return -hLimit(-v)
	Dim s As String = NumberFormat2(Floor(v*900),0,0,0,False)
	Dim pow10 As Float = Power(10,s.length-1)
	If (pow10 <= 1000) Then Return 0
	Return (s - (s Mod pow10))/1000
End Sub
private Sub hLimit(v As Float) As Float
	If v < 0 Then Return -lLimit(-v)
	Dim s As String = NumberFormat2(Ceil(v*1100),0,0,0,False)
	Dim pow10 As Float = Power(10,s.length-1)
	If (pow10 = 1000) Then Return 10
	Return (s + pow10 - (s Mod pow10))/1000
End Sub
private Sub setLimits(itemdata As data)
	If itemsMap.ContainsKey("limits") Then
		Dim Match As Matcher
		Match = Regex.Matcher(reExtractLimits, getItem("limits",""))
		If Match.Find And Match.GroupCount = 4 Then
			Minimum = Match.Group(4)
			Maximum = Match.Group(2)
			itemdata.Maximum = Match.Group(3)
			itemdata.Minimum = Match.Group(1)
		End If
	End If
End Sub
Sub pathinfo(dir As String) As Map
	Dim fInfo As Map = CreateMap("dirname":"","extension":"","filename":"","basename":"")
	Dim k As Int = dir.LastIndexOf("/")
	If k >= 0 Then	fInfo.Put("dirname",Left(dir,k))
	Dim fl As String = dir.SubString(k+1)
	fInfo.Put("basename",fl)
	k = fl.LastIndexOf(".")
	fInfo.Put("filename",fl)
	If k >= 0 Then
		fInfo.Put("filename",Left(fl,k))
		fInfo.Put("extension",fl.SubString(k+1))
	End If
	Return fInfo
End Sub